Index: issm/trunk/src/m/classes/thermal.py
===================================================================
--- issm/trunk/src/m/classes/thermal.py	(revision 18081)
+++ issm/trunk/src/m/classes/thermal.py	(revision 18301)
@@ -44,7 +44,7 @@
 
 		if self.isenthalpy:
-			return ['Enthalpy','Temperature','Waterfraction','Watercolumn','BasalforcingsMeltingRate']
+			return ['Enthalpy','Temperature','Waterfraction','Watercolumn','BasalforcingsGroundediceMeltingRate']
 		else:
-			return ['Temperature','BasalforcingsMeltingRate']
+			return ['Temperature','BasalforcingsGroundediceMeltingRate']
 
 	#}}}
Index: issm/trunk/src/m/classes/timestepping.m
===================================================================
--- issm/trunk/src/m/classes/timestepping.m	(revision 18081)
+++ issm/trunk/src/m/classes/timestepping.m	(revision 18301)
@@ -11,4 +11,5 @@
 		time_adapt      = 0;
 		cfl_coefficient = 0.;
+		interp_forcings = 1;
 	end
 	methods
@@ -46,4 +47,7 @@
 			obj.time_adapt=0;
 			obj.cfl_coefficient=0.5;
+
+			%should we interpolate forcings between timesteps?
+			obj.interp_forcings=1;
 		end % }}}
 		function md = checkconsistency(obj,md,solution,analyses) % {{{
@@ -54,4 +58,5 @@
 			md = checkfield(md,'fieldname','timestepping.time_adapt','numel',[1],'values',[0 1]);
 			md = checkfield(md,'fieldname','timestepping.cfl_coefficient','numel',[1],'>',0,'<=',1);
+			md = checkfield(md,'fieldname','timestepping.interp_forcings','numel',[1],'values',[0 1]);
 			if obj.final_time-obj.start_time<0,
 				md = checkmessage(md,'timestepping.final_time should be larger than timestepping.start_time');
@@ -66,4 +71,5 @@
 			fielddisplay(obj,'time_adapt','use cfl condition to define time step ? (0 or 1) ');
 			fielddisplay(obj,'cfl_coefficient','coefficient applied to cfl condition');
+			fielddisplay(obj,'interp_forcings','interpolate in time between requested forcing values ? (0 or 1)');
 
 		end % }}}
@@ -77,4 +83,5 @@
 			WriteData(fid,'object',obj,'fieldname','time_adapt','format','Boolean');
 			WriteData(fid,'object',obj,'fieldname','cfl_coefficient','format','Double');
+			WriteData(fid,'object',obj,'fieldname','interp_forcings','format','Boolean');
 		end % }}}
 	end
Index: issm/trunk/src/m/classes/timestepping.py
===================================================================
--- issm/trunk/src/m/classes/timestepping.py	(revision 18081)
+++ issm/trunk/src/m/classes/timestepping.py	(revision 18301)
@@ -18,4 +18,5 @@
 		self.time_adapt      = 0
 		self.cfl_coefficient = 0.
+		self.interp_forcings = 1
 		
 		#set defaults
@@ -30,4 +31,5 @@
 		string="%s\n%s"%(string,fielddisplay(self,"time_adapt","use cfl condition to define time step ? (0 or 1) "))
 		string="%s\n%s"%(string,fielddisplay(self,"cfl_coefficient","coefficient applied to cfl condition"))
+		string="%s\n%s"%(string,fielddisplay(self,"interp_forcings","interpolate in time between requested forcing values ? (0 or 1)"))
 		return string
 		#}}}
@@ -43,4 +45,7 @@
 		self.time_adapt=0
 		self.cfl_coefficient=0.5
+		
+		#should we interpolate forcings between timesteps?
+		self.interp_forcings=1
 
 		return self
@@ -55,4 +60,5 @@
 		if self.final_time-self.start_time<0:
 			md.checkmessage("timestepping.final_time should be larger than timestepping.start_time")
+		md = checkfield(md,'fieldname','timestepping.interp_forcings','numel',[1],'values',[0,1])
 
 		return md
@@ -67,3 +73,4 @@
 		WriteData(fid,'object',self,'fieldname','time_adapt','format','Boolean')
 		WriteData(fid,'object',self,'fieldname','cfl_coefficient','format','Double')
+		WriteData(fid,'object',self,'fieldname','interp_forcings','format','Boolean')
 	# }}}
Index: issm/trunk/src/m/consistency/checkfield.m
===================================================================
--- issm/trunk/src/m/consistency/checkfield.m	(revision 18081)
+++ issm/trunk/src/m/consistency/checkfield.m	(revision 18301)
@@ -23,7 +23,4 @@
 %   Usage:
 %      md = checkfield(md,fieldname,options);
-%
-%   Example:
-%      md = checkfield(md,'mesh.elementonbase','size',[md.mesh.numberofelements 1],'values',[0 1]);
 
 %get options
Index: issm/trunk/src/m/consistency/checkfield.py
===================================================================
--- issm/trunk/src/m/consistency/checkfield.py	(revision 18081)
+++ issm/trunk/src/m/consistency/checkfield.py	(revision 18301)
@@ -30,7 +30,4 @@
 	   Usage:
 	      md = checkfield(md,fieldname,options);
-
-	   Example:
-	      md = checkfield(md,'mesh.elementonbase','size',[md.mesh.numberofelements 1],'values',[0 1]);
 	"""
 
Index: issm/trunk/src/m/contrib/bamg/gmsh3d.m
===================================================================
--- issm/trunk/src/m/contrib/bamg/gmsh3d.m	(revision 18301)
+++ issm/trunk/src/m/contrib/bamg/gmsh3d.m	(revision 18301)
@@ -0,0 +1,103 @@
+function md=gmsh3d(md,domainfile,h),
+
+%Read domain
+domain=expread(domainfile);
+x   = domain.x(1:end-1);
+y   = domain.y(1:end-1);
+nbv = numel(x);
+
+%write files
+t1=clock; fprintf('%s','      writing initial mesh files...');
+fid=fopen('model.geo','w');
+fprintf(fid,['// Gmsh input file, created by ISSM on ' date '\n']);
+
+%Lower points
+for i=1:nbv,
+	fprintf(fid,'Point(%i) = {%8g, %8g, %8g};\n',i,x(i),y(i),0.);
+end
+%Upper points
+for i=1:nbv,
+	fprintf(fid,'Point(%i) = {%8g, %8g, %8g};\n',nbv+i,x(i),y(i),1.);
+end
+
+%Lower lines
+for i=1:nbv-1
+	fprintf(fid,'Line(%i) = {%i, %i};\n',i,i,i+1);
+end
+fprintf(fid,'Line(%i) = {%i, %i};\n',nbv,nbv,1);
+%Upper lines
+for i=nbv+1:2*nbv-1
+	fprintf(fid,'Line(%i) = {%i, %i};\n',i,i,i+1);
+end
+fprintf(fid,'Line(%i) = {%i, %i};\n',2*nbv,2*nbv,nbv+1);
+%Side lines
+for i=1:nbv
+	fprintf(fid,'Line(%i) = {%i, %i};\n',2*nbv+i,i,nbv+i);
+end
+
+counter = 3*nbv;
+ps = zeros(nbv+2,1);
+%Lower surface Loop and surface
+counter = counter+1;
+fprintf(fid,['Line Loop(' num2str(counter) ') = {']);
+for i=1:nbv-1
+	fprintf(fid,'%i,',i);
+end
+fprintf(fid,'%i};\n',nbv);
+fprintf(fid,['Plane Surface(' num2str(counter+1) ') = {' num2str(counter) '};\n']);
+ps(1)=counter+1;
+counter = counter+1;
+%Upper surface Loop and surface
+counter = counter+1;
+fprintf(fid,['Line Loop(' num2str(counter) ') = {']);
+for i=nbv+1:2*nbv-1
+	fprintf(fid,'%i,',i);
+end
+fprintf(fid,'%i};\n',2*nbv);
+ps(2)=counter+1;
+fprintf(fid,['Plane Surface(' num2str(counter+1) ') = {' num2str(counter) '};\n']);
+counter = counter+2;
+%Sides surfaces
+for i=1:nbv-1,
+	fprintf(fid,['Line Loop(' num2str(counter) ') = {' num2str(i) ',' num2str(2*nbv+i+1) ',-' num2str(nbv+i) ',-' num2str(2*nbv+i) '};\n']);
+	fprintf(fid,['Plane Surface(' num2str(counter+1) ') = {' num2str(counter) '};\n']);
+	ps(2+i)=counter+1;
+	counter=counter+2;
+end
+fprintf(fid,['Line Loop(' num2str(counter) ') = {' num2str(nbv) ',' num2str(2*nbv+1) ',-' num2str(2*nbv) ',-' num2str(3*nbv) '};\n']);
+fprintf(fid,['Plane Surface(' num2str(counter+1) ') = {' num2str(counter) '};\n']);
+ps(2+nbv)=counter+1;
+counter=counter+2;
+
+%Physical surfaces
+counter = counter+1;
+fprintf(fid,['Surface Loop(' num2str(counter) ') = {']);
+for i=1:numel(ps)-1
+	fprintf(fid,'%i,',ps(i));
+end
+fprintf(fid,'%i};\n',ps(end));
+fprintf(fid,['Physical Surface(1) = {' num2str(ps(2)) '};\n']);
+fprintf(fid,['Physical Surface(2) = {' num2str(ps(1)) '};\n']);
+fprintf(fid,['Physical Surface(3) = {']);
+for i=3:numel(ps)-1
+	fprintf(fid,'%i,',ps(i));
+end
+fprintf(fid,'%i};\n',ps(end));
+
+%Volume
+fprintf(fid,['Volume(1) = {' num2str(counter) '};\n']);
+fprintf(fid,['Physical Volume(2) = {1};\n']);
+
+%resolution
+fprintf(fid,'Mesh.CharacteristicLengthMax = %g;',h);
+fclose(fid);
+
+t2=clock;fprintf('%s\n',[' done (' num2str(etime(t2,t1)) ' seconds)']);
+
+%call gmsh
+fprintf('%s\n','      call gmsh...');
+system([issmdir() '/externalpackages/gmsh/install/gmsh -3 model.geo']);
+
+%plug new mesh
+t1=clock; fprintf('\n%s','      reading final mesh files...');
+md=importgmsh('model.msh',3);
Index: issm/trunk/src/m/contrib/bamg/yams.m
===================================================================
--- issm/trunk/src/m/contrib/bamg/yams.m	(revision 18081)
+++ issm/trunk/src/m/contrib/bamg/yams.m	(revision 18301)
@@ -108,6 +108,4 @@
 md.mesh.vertexonbase=ones(md.mesh.numberofvertices,1);
 md.mesh.vertexonsurface=ones(md.mesh.numberofvertices,1);
-md.mesh.elementonbase=ones(md.mesh.numberofelements,1);
-md.mesh.elementonsurface=ones(md.mesh.numberofelements,1);
 if strcmpi(Names.interp,'node'),
 	md.inversion.vx_obs=InterpFromGridToMesh(Vel.(Names.xname),Vel.(Names.yname),Vel.(Names.vxname),md.mesh.x,md.mesh.y,0);
Index: issm/trunk/src/m/contrib/hack/tres.m
===================================================================
--- issm/trunk/src/m/contrib/hack/tres.m	(revision 18081)
+++ issm/trunk/src/m/contrib/hack/tres.m	(revision 18301)
@@ -67,5 +67,5 @@
 	md.initialization.pressure=md.results.SteadystateSolution.Pressure;
 	md.initialization.temperature=md.results.SteadystateSolution.Temperature;
-	md.basalforcings.melting_rate=md.results.SteadystateSolution.BasalforcingsMeltingRate;
+	md.basalforcings.groundedice_melting_rate=md.results.SteadystateSolution.BasalforcingsGroundediceMeltingRate;
 
 	if md.inversion.iscontrol==1,
@@ -77,5 +77,5 @@
 elseif strcmpi(string,'thermal'),
 	md.initialization.temperature=md.results.ThermalSolution.Temperature;
-	md.basalforcings.melting_rate=md.results.ThermalSolution.BasalMeltingRate;
+	md.basalforcings.groundedice_melting_rate=md.results.ThermalSolution.BasalGroundediceMeltingRate;
 elseif strcmpi(string,'hydrology'),
 	md.initialization.watercolumn=md.results.HydrologySolution.Watercolumn;
Index: issm/trunk/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk/src/m/enum/EnumDefinitions.py	(revision 18081)
+++ issm/trunk/src/m/enum/EnumDefinitions.py	(revision 18301)
@@ -38,7 +38,13 @@
 def BalancethicknessStabilizationEnum(): return StringToEnum("BalancethicknessStabilization")[0]
 def BalancethicknessThickeningRateEnum(): return StringToEnum("BalancethicknessThickeningRate")[0]
+def BasalforcingsEnum(): return StringToEnum("Basalforcings")[0]
 def BasalforcingsGeothermalfluxEnum(): return StringToEnum("BasalforcingsGeothermalflux")[0]
-def BasalforcingsMeltingRateCorrectionEnum(): return StringToEnum("BasalforcingsMeltingRateCorrection")[0]
-def BasalforcingsMeltingRateEnum(): return StringToEnum("BasalforcingsMeltingRate")[0]
+def BasalforcingsGroundediceMeltingRateEnum(): return StringToEnum("BasalforcingsGroundediceMeltingRate")[0]
+def BasalforcingsFloatingiceMeltingRateEnum(): return StringToEnum("BasalforcingsFloatingiceMeltingRate")[0]
+def BasalforcingsDeepwaterMeltingRateEnum(): return StringToEnum("BasalforcingsDeepwaterMeltingRate")[0]
+def BasalforcingsDeepwaterElevationEnum(): return StringToEnum("BasalforcingsDeepwaterElevation")[0]
+def BasalforcingsUpperwaterElevationEnum(): return StringToEnum("BasalforcingsUpperwaterElevation")[0]
+def FloatingMeltRateEnum(): return StringToEnum("FloatingMeltRate")[0]
+def LinearFloatingMeltRateEnum(): return StringToEnum("LinearFloatingMeltRate")[0]
 def BedEnum(): return StringToEnum("Bed")[0]
 def BaseEnum(): return StringToEnum("Base")[0]
@@ -194,4 +200,5 @@
 def DamageEvolutionNumRequestedOutputsEnum(): return StringToEnum("DamageEvolutionNumRequestedOutputs")[0]
 def DamageEvolutionRequestedOutputsEnum(): return StringToEnum("DamageEvolutionRequestedOutputs")[0]
+def NewDamageEnum(): return StringToEnum("NewDamage")[0]
 def MaterialsRhoIceEnum(): return StringToEnum("MaterialsRhoIce")[0]
 def MaterialsRhoSeawaterEnum(): return StringToEnum("MaterialsRhoSeawater")[0]
@@ -322,4 +329,11 @@
 def SurfaceforcingsBNegEnum(): return StringToEnum("SurfaceforcingsBNeg")[0]
 def SMBhenningEnum(): return StringToEnum("SMBhenning")[0]
+def SMBcomponentsEnum(): return StringToEnum("SMBcomponents")[0]
+def SurfaceforcingsAccumulationEnum(): return StringToEnum("SurfaceforcingsAccumulation")[0]
+def SurfaceforcingsEvaporationEnum(): return StringToEnum("SurfaceforcingsEvaporation")[0]
+def SurfaceforcingsRunoffEnum(): return StringToEnum("SurfaceforcingsRunoff")[0]
+def SMBmeltcomponentsEnum(): return StringToEnum("SMBmeltcomponents")[0]
+def SurfaceforcingsMeltEnum(): return StringToEnum("SurfaceforcingsMelt")[0]
+def SurfaceforcingsRefreezeEnum(): return StringToEnum("SurfaceforcingsRefreeze")[0]
 def SurfaceforcingsIspddEnum(): return StringToEnum("SurfaceforcingsIspdd")[0]
 def SurfaceforcingsIssmbgradientsEnum(): return StringToEnum("SurfaceforcingsIssmbgradients")[0]
@@ -372,4 +386,5 @@
 def ThermalSolutionEnum(): return StringToEnum("ThermalSolution")[0]
 def TransientSolutionEnum(): return StringToEnum("TransientSolution")[0]
+def UzawaPressureAnalysisEnum(): return StringToEnum("UzawaPressureAnalysis")[0]
 def GiaSolutionEnum(): return StringToEnum("GiaSolution")[0]
 def GiaAnalysisEnum(): return StringToEnum("GiaAnalysis")[0]
@@ -475,5 +490,4 @@
 def FractionIncrementEnum(): return StringToEnum("FractionIncrement")[0]
 def FrictionEnum(): return StringToEnum("Friction")[0]
-def GroundinglineMeltingRateEnum(): return StringToEnum("GroundinglineMeltingRate")[0]
 def InternalEnum(): return StringToEnum("Internal")[0]
 def MassFluxEnum(): return StringToEnum("MassFlux")[0]
@@ -571,4 +585,6 @@
 def P1bubblecondensedEnum(): return StringToEnum("P1bubblecondensed")[0]
 def P2Enum(): return StringToEnum("P2")[0]
+def P2bubbleEnum(): return StringToEnum("P2bubble")[0]
+def P2bubblecondensedEnum(): return StringToEnum("P2bubblecondensed")[0]
 def P2xP1Enum(): return StringToEnum("P2xP1")[0]
 def P1xP2Enum(): return StringToEnum("P1xP2")[0]
@@ -580,6 +596,8 @@
 def MINIcondensedEnum(): return StringToEnum("MINIcondensed")[0]
 def TaylorHoodEnum(): return StringToEnum("TaylorHood")[0]
+def LATaylorHoodEnum(): return StringToEnum("LATaylorHood")[0]
 def XTaylorHoodEnum(): return StringToEnum("XTaylorHood")[0]
 def OneLayerP4zEnum(): return StringToEnum("OneLayerP4z")[0]
+def CrouzeixRaviartEnum(): return StringToEnum("CrouzeixRaviart")[0]
 def SaveResultsEnum(): return StringToEnum("SaveResults")[0]
 def BoolExternalResultEnum(): return StringToEnum("BoolExternalResult")[0]
@@ -623,4 +641,7 @@
 def IncrementalEnum(): return StringToEnum("Incremental")[0]
 def AugmentedLagrangianREnum(): return StringToEnum("AugmentedLagrangianR")[0]
+def AugmentedLagrangianRhopEnum(): return StringToEnum("AugmentedLagrangianRhop")[0]
+def AugmentedLagrangianRlambdaEnum(): return StringToEnum("AugmentedLagrangianRlambda")[0]
+def AugmentedLagrangianRholambdaEnum(): return StringToEnum("AugmentedLagrangianRholambda")[0]
 def AugmentedLagrangianThetaEnum(): return StringToEnum("AugmentedLagrangianTheta")[0]
 def NoneEnum(): return StringToEnum("None")[0]
Index: issm/trunk/src/m/exp/exp2shp.m
===================================================================
--- issm/trunk/src/m/exp/exp2shp.m	(revision 18301)
+++ issm/trunk/src/m/exp/exp2shp.m	(revision 18301)
@@ -0,0 +1,37 @@
+function exp2shp(shapefilename,expfilename,geometry)
+%SHPWRITE - write a shape file from a contour structure
+%
+%   Usage:
+%      exp2shp(shapefilename,expfilename,geometry)
+%
+%   Example:
+%      exp2shp('domainoutline.shp','domainoutline.exp')
+%      exp2shp('domainoutline.shp','domainoutline.exp','Polygon')
+%      exp2shp('massfluxgate.shp','massfluxgate.exp','Line')
+%
+%   See also SHPREAD, SHPWRITE, SHP2EXP
+
+shp=expread(expfilename);
+
+%initialize number of profile
+count=0;
+
+contours=struct([]);
+for i=1:length(shp),
+	if nargin < 3
+		if length(shp(1).x) == 1
+			geometry = 'Point';
+		elseif length(shp(1).x) < 3
+			geometry = 'Line';
+		else
+			geometry = 'Polygon';
+		end
+	end
+	contours(i).Geometry=geometry;
+	contours(i).id=i;
+	contours(i).X=shp(i).x;
+	contours(i).Y=shp(i).y;
+end
+	
+shapewrite(contours,shapefilename);
+end
Index: issm/trunk/src/m/extrusion/project2d.m
===================================================================
--- issm/trunk/src/m/extrusion/project2d.m	(revision 18081)
+++ issm/trunk/src/m/extrusion/project2d.m	(revision 18301)
@@ -2,9 +2,7 @@
 %PROJECT2D - returns the value of a field for a given layer of the mesh
 %
-%   project 'value' vector taken at layer 'layer' from extruded 2d-3d mesh onto 2d mesh 
-%   used to do the extrusion. This routine is used to compare values between a 2d-3d mesh
-%   at a certain layer, and the equivalent value (if it exists), on the original 2d mesh. 
-%   This routine relies heavily on projections (contained in 3d model md) recored during 
-%   the extrude operation.
+%   returns the value of a vector for a given layer from extruded mesh onto the 2d mesh 
+%   used to do the extrusion. This function is used to compare values between different
+%   layers of a 3d mesh.
 %
 %   Usage:
@@ -12,5 +10,6 @@
 %
 %   Example:
-%      vel2=project2d(md3d,md3d.vel,2);
+%      vel2=project2d(md3d,md3d.initialization.vel,2);
+%      returns the velocity of the second layer (1 is the base)
 
 %some checks on list of arguments
Index: issm/trunk/src/m/extrusion/project2d.py
===================================================================
--- issm/trunk/src/m/extrusion/project2d.py	(revision 18081)
+++ issm/trunk/src/m/extrusion/project2d.py	(revision 18301)
@@ -5,13 +5,8 @@
 	returns the value of a field for a given layer of the mesh
 	
-	project 'value' vector taken at layer 'layer' from extruded 2d-3d
-	mesh onto 2d mesh used to do the extrusion. This routine is used to
-	compare values between a 2d-3d mesh at a certain layer, and the
-	equivalent value (if it exists), on the original 2d mesh.	
 
-	Note: for consistency with usage in ISSM, layers are indexed starting
-	from one.  This routine accounts for the fact that python indexes from
-	zero.  In other words, when using this function consider the bottom
-	layer as layer=1.  
+   returns the value of a vector for a given layer from extruded mesh onto the 2d mesh 
+   used to do the extrusion. This function is used to compare values between different
+   layers of a 3d mesh.
 
    Usage:
@@ -19,5 +14,6 @@
 
    Example:
-      vel2=project2d(md3d,md3d.vel,2)
+      vel2=project2d(md3d,md3d.initialization.vel,2);
+      returns the velocity of the second layer (1 is the base)
 	'''
 
Index: issm/trunk/src/m/interp/interp.py
===================================================================
--- issm/trunk/src/m/interp/interp.py	(revision 18081)
+++ issm/trunk/src/m/interp/interp.py	(revision 18301)
@@ -45,6 +45,8 @@
 	# create sub-vectors that just cover the limits of xi and yi
 	# TODO x,y not necessarily a grid, so need a better definition of dx,dy (e.g. average element size)
-	dx=x[1]-x[0]
-	dy=y[1]-y[0]
+	dx=500
+	dy=500
+	#dx=x[1]-x[0]
+	#dy=y[1]-y[0]
 	xlim=[min(xi)-dx,max(xi)+dx]
 	ylim=[min(yi)-dy,max(yi)+dy]
@@ -76,5 +78,5 @@
 		xyinterp=npy.dstack([xi,yi])[0]
 		xg,yg=npy.meshgrid(subx,suby)
-		xydata=npy.dstack([xg.ravel(),yg.ravel()])[0]
+		xydata=npy.dstack([subx,suby])[0]
 		tree=cKDTree(xydata)
 		nearest=tree.query(xyinterp)[1]
Index: issm/trunk/src/m/mech/backstressfrominversion.m
===================================================================
--- issm/trunk/src/m/mech/backstressfrominversion.m	(revision 18081)
+++ issm/trunk/src/m/mech/backstressfrominversion.m	(revision 18301)
@@ -23,7 +23,6 @@
 %
 %   Return values:
-%		'backstress' is the inferred backstress necessary to balance the
-%		analytical solution (keeping damage within its appropriate limits, e.g. D
-%		in [0,1]).
+%		'backstress' is the inferred backstress based on the analytical
+%		solution for ice shelf creep
 %
 %   Usage:
Index: issm/trunk/src/m/mech/backstressfrominversion.py
===================================================================
--- issm/trunk/src/m/mech/backstressfrominversion.py	(revision 18081)
+++ issm/trunk/src/m/mech/backstressfrominversion.py	(revision 18301)
@@ -8,5 +8,5 @@
 
 	This routine computes backstress based on the analytical formalism of
-	Thomas (1973) and Borstad et al. (2013, The Cryoshpere).  The model
+	Thomas (1973) and Borstad et al. (2013, The Cryosphere).  The model
 	must contain inversion results for ice rigidity.  Strain rates must
 	also be included, either from observed or modeled velocities.  Ice
@@ -29,7 +29,6 @@
 
    Return values:
-		'backstress' is the inferred backstress necessary to balance the
-		analytical solution (keeping damage within its appropriate limits, e.g. D
-		in [0,1]).
+		'backstress' is the inferred backstress based on the analytical
+		solution for ice shelf creep
 
    Usage:
Index: issm/trunk/src/m/mech/basalstress.m
===================================================================
--- issm/trunk/src/m/mech/basalstress.m	(revision 18081)
+++ issm/trunk/src/m/mech/basalstress.m	(revision 18301)
@@ -1,4 +1,6 @@
 function [bx by b]=basalstress(md)
 %BASALSTRESS - compute basal stress from basal drag and geometric information. 
+%
+%      Computes basal stress from geometric information and ice velocity in md.initialization.
 %
 %   Usage:
Index: issm/trunk/src/m/mech/calcbackstress.m
===================================================================
--- issm/trunk/src/m/mech/calcbackstress.m	(revision 18301)
+++ issm/trunk/src/m/mech/calcbackstress.m	(revision 18301)
@@ -0,0 +1,64 @@
+function backstress=calcbackstress(md,varargin)
+%BACKSTRESSFROMINVERSION - compute ice shelf backstress  
+%
+%	 This routine computes backstress based on the analytical formalism of
+%	 Thomas (1973) and Borstad et al. (2013) based on the ice rigidity,
+%	 thickness, the densities of ice and seawater, and (optionally)
+%	 damage. Strain rates must also be included, either from observed or
+%	 modeled velocities.
+
+%   Available options:
+%		- 'smoothing'	: the amount of smoothing to be applied to the strain rate data.
+%								Type 'help averaging' for more information on its
+%								usage. Defaults to 0.
+%		- 'coordsys'	: coordinate system for calculating the strain rate
+%							components. Must be one of: 
+%				'longitudinal': x axis aligned along a flowline at every point (default)
+%				'principal': x axis aligned along maximum principal strain rate
+%					at every point
+%				'xy': x and y axes same as in polar stereographic projection 
+%
+%   Return values:
+%		'backstress' is the inferred backstress based on the analytical
+%		solution for ice shelf creep
+%
+%   Usage:
+%      backstress=calcbackstress(md,options)
+%
+%   Example:
+%      backstress=backstressfrominversion(md,'smoothing',2,'coordsys','longitudinal');
+
+% check inputs
+if (nargin<1),
+	help backstressfrominversion
+	error('bad usage');
+end
+if isempty(fieldnames(md.results)),
+	error(['md.results.strainrate is not present.  Calculate using md=mechanicalproperties(md,vx,vy)']);
+end
+if dimension(md.mesh)~=2,
+	error('only 2d model supported currently');
+end
+if any(md.flowequation.element_equation~=2),
+	disp('Warning: the model has some non SSA elements. These will be treated like SSA elements');
+end
+
+% process options
+options = pairoptions(varargin{:});
+smoothing = getfieldvalue(options,'smoothing',0);
+coordsys = getfieldvalue(options,'coordsys','longitudinal');
+tempmask = getfieldvalue(options,'tempmask',false);
+
+T=0.5*md.materials.rho_ice*md.constants.g*(1-md.materials.rho_ice/md.materials.rho_water)*md.geometry.thickness;
+n=averaging(md,md.materials.rheology_n,0);
+B=md.materials.rheology_B;
+if md.damage.isdamage,
+	D=md.damage.D
+else
+	D=0.
+
+[a0,b0,theta0,ex0]=thomasparams(md,'eq','Thomas','smoothing',smoothing,'coordsys',coordsys);
+
+% analytical backstress solution
+backstress=T-(1.-D).*B.*sign(ex0).*(2+a0).*abs(ex0).^(1./n)./((1+a0+a0.^2+b0.^2).^((n-1)/2./n));
+backstress(find(backstress<0))=0;
Index: issm/trunk/src/m/mech/calcbackstress.py
===================================================================
--- issm/trunk/src/m/mech/calcbackstress.py	(revision 18301)
+++ issm/trunk/src/m/mech/calcbackstress.py	(revision 18301)
@@ -0,0 +1,66 @@
+import numpy as npy
+from averaging import averaging
+from thomasparams import thomasparams
+
+def calcbackstress(md,**kwargs):
+	'''
+	Compute ice shelf backstress.
+
+	This routine computes backstress based on the analytical formalism of
+	Thomas (1973) and Borstad et al. (2013, The Cryosphere) based on the
+	ice rigidity, thickness, the densities of ice and seawater, and
+	(optionally) damage.  Strain rates must also be included, either from
+	observed or modeled velocities. 
+	
+	Available options:
+		- 'smoothing'	: the amount of smoothing to be applied to the strain rate data.
+								Type 'help averaging' for more information on its
+								usage. Defaults to 0.
+		- 'coordsys'	: coordinate system for calculating the strain rate
+							components. Must be one of: 
+				'longitudinal': x axis aligned along a flowline at every point (default)
+				'principal': x axis aligned along maximum principal strain rate
+					at every point
+				'xy': x and y axes same as in polar stereographic projection 
+
+   Return values:
+		'backstress' is the inferred backstress based on the analytical
+		solution for ice shelf creep
+
+   Usage:
+      backstress=calcbackstress(md,options)
+
+   Example:
+      backstress=calcbackstress(md,'smoothing',2,'coordsys','longitudinal')
+	'''
+
+	# unpack kwargs
+	smoothing=kwargs.pop('smoothing',0)
+	if 'smoothing' in kwargs: del kwargs['smoothing']
+	coordsys=kwargs.pop('coordsys','longitudinal')
+	if 'coordsys' in kwargs: del kwargs['coordsys']
+	assert len(kwargs)==0, 'error, unexpected or misspelled kwargs'
+
+	# some checks
+	if not hasattr(md.results,'strainrate'):
+		raise StandardError('md.results.strainrate not present.  Calculate using md=mechanicalproperties(md,vx,vy)')
+	if not '2d' in md.mesh.__doc__:
+		raise StandardError('only 2d (planview) model supported currently')
+	if any(md.flowequation.element_equation!=2):
+		raise StandardError('Warning: the model has some non-SSA elements.  These will be treated like SSA elements')
+
+	T=0.5*md.materials.rho_ice*md.constants.g*(1-md.materials.rho_ice/md.materials.rho_water)*md.geometry.thickness
+	n=averaging(md,md.materials.rheology_n,0)
+	B=md.materials.rheology_B
+	if md.damage.isdamage:
+		D=md.damage.D
+	else:
+		D=0.
+	
+	a0,b0,theta0,ex0=thomasparams(md,eq='Thomas',smoothing=smoothing,coordsys=coordsys)
+	
+	# analytical backstress solution
+	backstress=T-(1.-D)*B*npy.sign(ex0)*(2+a0)*npy.abs(ex0)**(1./n)/((1+a0+a0**2+b0**2)**((n-1.)/2./n))
+	backstress[npy.nonzero(backstress<0)]=0
+
+	return backstress
Index: issm/trunk/src/m/mech/steadystateiceshelftemp.m
===================================================================
--- issm/trunk/src/m/mech/steadystateiceshelftemp.m	(revision 18081)
+++ issm/trunk/src/m/mech/steadystateiceshelftemp.m	(revision 18301)
@@ -12,5 +12,5 @@
 %	 The model md must also contain the fields: 
 %	 md.geometry.thickness
-%	 md.basalforcings.melting_rate (positive for melting, negative for freezing)
+%	 md.basalforcings.floatingice_melting_rate (positive for melting, negative for freezing)
 
 %   Usage:
@@ -38,5 +38,5 @@
 
 %vertical velocity of ice shelf, calculated from melting rate 
-wi=md.materials.rho_water/md.materials.rho_ice.*md.basalforcings.melting_rate; 
+wi=md.materials.rho_water/md.materials.rho_ice.*md.basalforcings.floatingice_melting_rate; 
 
 %temperature profile is linear if melting rate is zero, depth-averaged temp is simple average in this case
Index: issm/trunk/src/m/mech/steadystateiceshelftemp.py
===================================================================
--- issm/trunk/src/m/mech/steadystateiceshelftemp.py	(revision 18081)
+++ issm/trunk/src/m/mech/steadystateiceshelftemp.py	(revision 18301)
@@ -13,5 +13,5 @@
 	The model md must also contain the fields: 
 	md.geometry.thickness
-	md.basalforcings.melting_rate (positive for melting, negative for freezing)
+	md.basalforcings.floatingice_melting_rate (positive for melting, negative for freezing)
 
    Usage:
@@ -37,5 +37,5 @@
 	
 	#vertical velocity of ice shelf, calculated from melting rate 
-	wi=md.materials.rho_water/md.materials.rho_ice*md.basalforcings.melting_rate 
+	wi=md.materials.rho_water/md.materials.rho_ice*md.basalforcings.floatingice_melting_rate 
 	
 	#temperature profile is linear if melting rate is zero, depth-averaged temp is simple average in this case
Index: issm/trunk/src/m/mesh/squaremesh.py
===================================================================
--- issm/trunk/src/m/mesh/squaremesh.py	(revision 18081)
+++ issm/trunk/src/m/mesh/squaremesh.py	(revision 18301)
@@ -2,4 +2,5 @@
 from NodeConnectivity import NodeConnectivity
 from ElementConnectivity import ElementConnectivity 
+from mesh2d import mesh2d
 
 def squaremesh(md,Lx,Ly,nx,ny):
Index: issm/trunk/src/m/miscellaneous/prctile_issm.m
===================================================================
--- issm/trunk/src/m/miscellaneous/prctile_issm.m	(revision 18081)
+++ issm/trunk/src/m/miscellaneous/prctile_issm.m	(revision 18301)
@@ -26,10 +26,10 @@
 		psize=size(p);
 		if size(p,2)>1
-			p=transp(p);
+			p=transpose(p);
 		end
 
 		xsize=size(x);
 		if dim==2
-			x=transp(x);
+			x=transpose(x);
 		end
 
@@ -46,5 +46,5 @@
 %  set up percent values and interpolate
 
-				xi=transp(100.*([1:n]-0.5)/n);
+				xi=transpose(100.*([1:n]-0.5)/n);
 				y=interp1q(xi,x,p);
 
@@ -80,5 +80,5 @@
 		if (min(xsize)==1 && xsize(dim)>1 && psize(2)>1) || ...
 		   (min(xsize)> 1 && dim==2)
-			y=transp(y);
+			y=transpose(y);
 		end
 	end
